Subject: Re: knob to disable locally-originating qdisc optimisation?

From: Stephen Hemminger <[email-masked]>
Date: Tue, 16 May 2023 16:01:11 -0700

On Wed, 17 May 2023 00:11:02 +0200
Toke Høiland-Jørgensen <[email-masked]> wrote:

> Thorsten Glaser <[email-masked]> writes:
> 
> > On Tue, 16 May 2023, Toke Høiland-Jørgensen wrote:
> >  
> >>Pushing stuff into a
> >>qdisc so it can be ECN-marked is also nonsensical for locally generated
> >>traffic; you don't need the ECN roundtrip, you can just directly tell
> >>the local TCP sender to slow down (which is exactly what TSQ does).  
> >
> > Yes, but the point of this exercise is to develop algorithms which
> > react to ECN marking; in production, the RAN BTS will do the marking
> > so the sender will not be at the place where congestion happens, so
> > adding that kind of insight is not needed.
> >
> > Some people have asked for the ability to make Linux behave as if
> > the sender was remote to ease the test setup (i.e. require one less
> > machine), nothing more.  
> 
> Well, if it's a custom qdisc you could just call skb_orphan() on the
> skbs when enqueueing them?
> 
> -Toke

If your qdisc was upstream, others could collaborate to resolve the issue.
As it stands, the kernel development process is intentionally hostile
to out of tree developer changes like this.